/*
[WebPage Dododo] - a Gold Experience Library for Web 5.0 World

License:
	MIT-style license
	  &
	ARAKI Hirohiko license

WebPageDododo Copyright:
	Copyright (c) 2007 cahm, <http://massacre.s59.xrea.com>
*/

(function(){
	var WPD = {
		VERSION: '1.0.0'
	};
	
	// constants
	var DDDTYPES = 24;
	var IMGSIZE = 640;
	
	var MAXDDD = 29;
	var MAXSIZE = 15;
	var THUMB_SIZE = 64;
	var MENU_WIDTH = 640;
	var FPS = 50;
	var STEPS = 10;
	
	var FONT_COLOR     = '#000000';
	var MENU_BGCOLOR   = '#f1f1f1';
	var BORDER_COLOR   = '#999999';
	var TABLE_BGCOLOR1 = '#333333';
	var TABLE_BGCOLOR2 = '#666666';
	
	var MENU_HTML =
	'<div id="WebPageDododo_menu" style="visibility: hidden;">' +
	'<form id="WebPageDododo_form" action="#" onsubmit="return false;">' +
	'<div id="WebPageDododo_delete">　</div>' +
	'<div class="WebPageDododo_config1">' +
	'<label for="WebPageDododo_type">振動</label>：<select id="WebPageDododo_type">' +
	'</select>　' +
	'<label for="WebPageDododo_power">振動力</label>：<select id="WebPageDododo_power">' +
	'	<option value="5">A(超スゴイ)</option>' +
	'	<option value="4">B(スゴイ)</option>' +
	'	<option value="3" selected="selected">C(普通)</option>' +
	'	<option value="2">D(ニガテ)</option>' +
	'	<option value="1">E(超ニガテ)</option>' +
	'</select>　' +
	'<label for="WebPageDododo_pitch">スピード</label>：<select id="WebPageDododo_pitch">' +
	'	<option value="200">A(超スゴイ)</option>' +
	'	<option value="400">B(スゴイ)</option>' +
	'	<option value="600" selected="selected">C(普通)</option>' +
	'	<option value="800">D(ニガテ)</option>' +
	'	<option value="1000">E(超ニガテ)</option>' +
	'</select><br/>' +
	'<label for="WebPageDododo_size">サイズ</label>：<select id="WebPageDododo_size">' +
	'	<option value="1">1　</option>' +
	'	<option value="2">2　</option>' +
	'	<option value="3">3　</option>' +
	'	<option value="4">4　</option>' +
	'	<option value="5" selected="selected">5　</option>' +
	'	<option value="6">6　</option>' +
	'	<option value="7">7　</option>' +
	'	<option value="8">8　</option>' +
	'	<option value="9">9　</option>' +
	'	<option value="10">10　</option>' +
	'	<option value="11">11　</option>' +
	'	<option value="12">12　</option>' +
	'	<option value="13">13　</option>' +
	'	<option value="14">14　</option>' +
	'	<option value="15">15　</option>' +
	'</select>　' +
	'<input type="button" value="詳細設定" id="WebPageDododo_toggleDetail" />' +
	'</div>' +
	'<div class="WebPageDododo_config2">' +
	'<label for="WebPageDododo_adjustment">位置/サイズの調整</label>：<select id="WebPageDododo_adjustment">' +
	'	<option value="0" selected="selected">ウィンドウサイズによらず常に一定　</option>' +
	'	<option value="1">ウィンドウ横サイズに合わせて調整　</option>' +
	'	<option value="2">ウィンドウ縦サイズに合わせて調整　</option>' +
	'	<option value="3">ウィンドウサイズに合わせて調整　</option>' +
	'</select>　' +
	'<label for="WebPageDododo_base">基準</label>：<select id="WebPageDododo_base">' +
	'	<option value="0">左上　</option>' +
	'	<option value="1">上　</option>' +
	'	<option value="2">右上　</option>' +
	'	<option value="3">左　</option>' +
	'	<option value="4" selected="selected">中央　</option>' +
	'	<option value="5">右　</option>' +
	'	<option value="6">左下　</option>' +
	'	<option value="7">下　</option>' +
	'	<option value="8">右下　</option>' +
	'</select><br />' +
	'<input type="text" value="" id="WebPageDododo_search" /><br />' +
	'<input type="text" value="2" id="WebPageDododo_prime" />' +
	'<input type="button" value="次の素数" id="WebPageDododo_nextPrime" />' +
	'</div>' +
	'</form>' +
	'</div>';
	
	var LIBRATIONS = [];
	LIBRATIONS[0] = {
		name: 'なし',
		func: function(){}
	};
	LIBRATIONS[1] = {
		name: '縦振動(1)',
		func: function(power){
			this.step = !this.step;
			var dy = this.size * power / 10 * (this.step ? -1 : 1);
			this.draw(this.x, this.y + dy, this.size);
		}
	};
	LIBRATIONS[2] = {
		name: '縦振動(2)',
		func: function(power){
			this.step = !this.step;
			var dx = Math.floor(Math.random() * power) - power / 2;
			var dy = this.size * power / 10 * (this.step ? -1 : 1);
			this.draw(this.x + dx, this.y + dy, this.size);
		}
	};
	LIBRATIONS[3] = {
		name: 'ランダム振動',
		func: function(power){
			var dx = Math.floor(Math.random() * this.size * power / 5) - this.size / 2;
			var dy = Math.floor(Math.random() * this.size * power / 5) - this.size / 2;
			this.draw(this.x + dx, this.y + dy, this.size);
		}
	};
	LIBRATIONS[4] = {
		name: '拡大',
		func: function(power){
			this.step = !this.step;
			var zoom = this.step ? (1 + power/10) : 1;
			this.draw(this.x, this.y, this.size * zoom);
		}
	};
	LIBRATIONS[5] = {
		name: 'ランダム拡大',
		func: function(power){
			var zoom = Math.floor(Math.random() * power * 10) / 100 + 1;
			this.draw(this.x, this.y, this.size * zoom);
		}
	};
	
	// variables
	var ddds = [];
	var path = '';
	var timer;
	var size = { x: 800, y: 600 };
	var changeable = true;
	var maxId = 1;
	var maxZIndex = 10000;
	var drag = {
		flag: false,
		elm: null,
		_this: null,
		offX: 0,
		offY: 0,
		size: 0
	};
	
	var align  = 'right';	// 'left'
	var valign = 'bottom';	// 'top'
	
	var isIE = !!window.ActiveXObject;
	var isIE6 = isIE && !window.XMLHttpRequest;
	var isGecko = document.getBoxObjectFor != null;
	var declinationFlag = false;
	
	function ready(){
		var menu_hidden   = true;
		var detail_hidden = true;
		var slideTimer = null;
		
		var div        = readyMainDiv();
		var menu       = readyMenu(div);
		var table      = readyTable(menu);
		var openButton;
		if (changeable){
			openButton = readyOpenButton(div);
			readyTheHand(div);
		}
		readyForm();
		if (isIE6){
			setStyle(div,        'position', 'absolute');
			setStyle(menu,       'position', 'absolute');
			setStyle(openButton, 'position', 'absolute');
			setStyle(div, 'overflow', 'hidden');
			setTimeout(function(){
				if (menu.offsetWidth < MENU_WIDTH + 10) setStyle(menu, 'width', MENU_WIDTH + 10 + 'px');
				var size = getWindowSize();
				if ((align  == 'right'  && openButton.offsetLeft + openButton.offsetWidth  != size.x) ||
				    (valign == 'bottom' && openButton.offsetTop  + openButton.offsetHeight != size.y)){
				    declinationFlag = true;
				    setStyle(openButton, align, 0);
				    setStyle(openButton, valign, 0);
				    setStyle(menu, align, 0);
				}
			}, 10);
		}
		
		readyEvents();
		
		function readyMainDiv(){
			var div = createElement('div', {
				id: 'WebPageDododo',
				innerHTML: MENU_HTML
			}, {});
			document.body.appendChild(div);
			return div;
		}
		
		function readyMenu(div){
			var menu = $('menu');
			setStyles(menu, {
				width: MENU_WIDTH + 'px',
				backgroundColor: MENU_BGCOLOR,
				color: FONT_COLOR,
				borderLeftWidth:    align == 'right'  ? '10px' : 0,
				borderRightWidth:   align != 'right'  ? '10px' : 0,
				borderTopWidth:    valign == 'bottom' ? '10px' : 0,
				borderBottomWidth: valign != 'bottom' ? '10px' : 0,
				borderColor: BORDER_COLOR
			});
			setStyle(menu, align , 0);
			setStyle(menu, valign, 0);
			
			setStyle($('delete'), 'float', align == 'right' ? 'left' : 'right');
			return menu;
		}
		
		function readyTable(menu){
			var table = createElement('table', {}, { width: MENU_WIDTH + 'px' });
			var tbody = createElement('tbody', {}, {});
			table.appendChild(tbody);
			
			var maxX = Math.floor(MENU_WIDTH / THUMB_SIZE);
			for(var y=0; y*maxX < DDDTYPES; y++){
				var tr = createElement('tr', {}, { height: THUMB_SIZE + 'px' });
				
				for(var x=0; x<maxX; x++){
					var td = createElement('td', {}, {
						backgroundColor: ((x + y) % 2) ? TABLE_BGCOLOR1 : TABLE_BGCOLOR2,
						width: THUMB_SIZE + 'px'
					});
					
					if (y*maxX + x < DDDTYPES){
						var img = createElement('img', {
							src: path + (y*maxX + x + 1) + '.png',
							alt: '',
							width: THUMB_SIZE,
							height: THUMB_SIZE
						}, {});
						(function(){
							var type = y * maxX + x + 1;
							if (changeable) img.onmousedown = function(event){
								addDdd(event, type);
							};
						})();
						td.appendChild(img);
					}
					tr.appendChild(td);
				}
				tbody.appendChild(tr);
			}
			if (valign != 'bottom') menu.appendChild(table);
			else                    menu.insertBefore(table, menu.childNodes[0]);
			return table;
		}
		
		function readyTheHand(div){
			var theHand = createElement('img', {
				id:  'WebPageDododo_theHand',
				src: path + 'thehand2.png',
				alt: 'ザ・ハンド',
				width: 48,
				height: 48,
				onmousedown: startDelete
			}, {
				position: isIE6 ? 'absolute': 'fixed',
				visibility: 'hidden'
			});
			setStyle(theHand,  align, MENU_WIDTH - (align == 'right' ? 48 : 64) + 'px');
			setStyle(theHand, valign, valign == 'bottom' ? '16px' : 0);
			div.appendChild(theHand);
			
			function startDelete(event){
				event = new Event(event);
				drag.flag = true;
				drag.elm = $('theHand');
				drag._this = null;
				drag.offX = 0;
				drag.offY = 0;
				drag.size = 48;
				if ( align == 'right' ) setStyle(drag.elm, 'right',  'auto');
				if (valign == 'bottom') setStyle(drag.elm, 'bottom', 'auto');
				setStyles(drag.elm, {
					left: event.client.x - drag.size / 2 + 'px',
					top:  event.client.y - drag.size / 2 + 'px'
				});
				addEvent(document, 'mousemove', draggingTheHand);
				addEvent(document, 'mouseup', endDelete);
				returnBasicPosition();
				event.stop();
			}
			function draggingTheHand(event){
				event = new Event(event);
				dragging(event);
				var tmp = [];
				for(var i=0; i<ddds.length; i++){
					if (Math.abs(event.client.x - ddds[i].x) < ddds[i].size / 3 &&
					    Math.abs(event.client.y - ddds[i].y) < ddds[i].size / 3){
					    ddds[i].gaon();
					} else {
						tmp.push(ddds[i]);
					}
				}
				if (tmp.length != ddds.length){
					ddds = tmp;
					setCookie();
				}
			}
			function endDelete(event){
				if (!drag.flag) return;
				if ( align == 'right' ) setStyle(drag.elm, 'left', 'auto');
				if (valign == 'bottom') setStyle(drag.elm, 'top',  'auto');
				setStyle(drag.elm,  align, MENU_WIDTH - (align == 'right' ? 48 : 64) + 'px');
				setStyle(drag.elm, valign, valign == 'bottom' ? detail_hidden ? '16px' : '112px' : 0);
				drag.flag = false;
				removeEvent(document, 'mousemove', draggingTheHand);
				removeEvent(document, 'mouseup', endDelete);
			}
		}
		
		function readyForm(){
			if (align != 'right') setStyle($('form'), 'marginLeft', '32px');
			$('search').readOnly = true;
			for(var i=0; i<LIBRATIONS.length; i++){
				var option = createElement('option', {
					innerHTML: LIBRATIONS[i].name,
					value: i
				}, {});
				$('type').appendChild(option);
			}
			$('type').selectedIndex = 0;
		}
		
		function readyOpenButton(div){
			var img = createElement('img', {
				id: 'WebPageDododo_icon',
				src: path + 'wpd.png',
				alt: 'ウェブページドドド',
				onclick: toggle
			}, {});
			setStyle(img,  align, 0);
			setStyle(img, 'bottom', 'auto');
			setStyle(img, valign, 0);
			div.appendChild(img);
			return img;
		}
		
		
		function readyEvents(){
			var confirmFlag = true;
			addEvent($('toggleDetail'), 'click', toggleDetail);
			addEvent($('nextPrime'   ), 'click', nextPrime);
			addEvent($('type'),  'change', changeType);
			addEvent($('power'), 'change', setCookie);
			addEvent($('pitch'), 'change', function(){ setTimer(); setCookie(); });
			addEvent($('adjustment'), 'change', changeAdjustment);
			addEvent($('base'),       'change', setCookie);
			
			// for ie6
			if (isIE6){
				addEvent(window, 'scroll', function(){
					setStyles($(), {
						top:  document.body.scrollTop,
						left: document.body.scrollLeft
					});
				});
				
				onResize_IE6();
				addEvent(window, 'resize', onResize_IE6);
				function onResize_IE6(){
					
					var size = getWindowSize();
					setStyles($(), {
						width:  size.x + 'px',
						height: size.y + 'px'
					});
				}
			}
			
			function nextPrime(){
				var num = parseInt($F('prime'));
				if (num < 2){
					$('prime').value = 2;
					return;
				}
				if (confirmFlag && num > 10000){
					if (!confirm(
						"大きな素数の計算には非常に時間がかかる恐れがあります。\n" +
						"本当に実行してもよろしいですか？\n\n" +
						"【警告】\n" +
						"YES!YES!YES! を選ばれた場合、次回からはこの確認を行いません。\n" +
						"何度も言わせるって事は無駄なんだ…無駄だから嫌いなんだ\n" +
						"無駄無駄……"
					)) return;
					confirmFlag = false;
				}
				$('nextPrime').disabled = true;
				_nextPrime(num);
			}
			function _nextPrime(num){
				if (num % 2 == 1) num++;
				var plusNum = (num < 10000) ? 200 : (num < 100000) ? 20 : 2;
				for(var i=num+1; i<=num+plusNum; i+=2){
					var max = (i - 1) / 2;
					for(var j=3; j<max; j+=2){
						if (i % j == 0) break;
					}
					if (j < max) continue;
					$('prime').value = i;
					$('nextPrime').disabled = false;
					return;
				}
				(function(num){
					setTimeout(function(){_nextPrime(num)}, 10);
				})(num + plusNum);
			}
		}
		
		
		function toggle(){
			if (slideTimer) return;
			var elm = $('menu');
			if (menu_hidden){
				setStyle(elm, 'visibility', 'visible');
				slide(elm, valign, [-elm.offsetHeight-1, 0], '**px', function(){
					menu_hidden = false;
					setStyle($('theHand'), 'visibility', 'visible');
				});
			} else {
				setStyle($('theHand'), 'visibility', 'hidden');
				slide(elm, valign, [0, -elm.offsetHeight-1], '**px', function(){
					menu_hidden = true;
					setStyle(elm, 'visibility', 'hidden');
					if (valign == 'bottom' && window.opera) setStyle(elm, 'bottom', 0);
				});
			}
		}
		function toggleDetail(){
			if (slideTimer || menu_hidden) return;
			var elm = $('form');
			if (detail_hidden){
				if (valign == 'bottom') setStyle($('theHand'), 'visibility', 'hidden');
				slide(elm, 'height', [64, 160], '**px', function(){
					detail_hidden = false;
					if (valign == 'bottom'){
						setStyles($('theHand'), {
							visibility: 'visible', bottom : '112px'
						});
					}
				});
			} else {
				if (valign == 'bottom') setStyle($('theHand'), 'visibility', 'hidden');
				slide(elm, 'height', [160, 64], '**px', function(){
					detail_hidden = true;
					if (valign == 'bottom'){
						setStyles($('theHand'), {
							visibility: 'visible', bottom: '16px'
						});
					}
				});
			}
			$('toggleDetail').value = detail_hidden ? '簡易設定' : '詳細設定';
		}
		function slide(elm, style, range, str, func){
			var step = 0;
			slideTimer = setInterval( function(){ _slide(elm, style, range, str, func); }, 1000/FPS)
			_slide(elm, style, range, str, func);
			
			function _slide(elm, style, range, str, func){
				var x = (1 - Math.cos(Math.PI * step / STEPS)) * (range[1] - range[0]) / 2 + range[0];
				setStyle(elm, style, str.replace('**', step >= STEPS ? range[1] : x));
				if (++step > STEPS){
					func();
					clearInterval(slideTimer);
					slideTimer = null;
				}
			}
		}
	}
	
	
	// Basic Functions
	function $(id){
		return document.getElementById(id ? ('WebPageDododo_' + id) : 'WebPageDododo');
	}
	function $F(id){
		var elm = $(id);
		return elm ? elm.value : undefined;
	}
	
	function createElement(tagName, attributes, styles){
		var elm = document.createElement(tagName);
		for(var i in attributes){
			elm[i] = attributes[i];
		}
		setStyles(elm, styles);
		return elm;
	}
	
	function setStyle(elm, type, value){
		if (!elm) return;
		switch(type){
		case 'float':
			elm.style[isIE ? 'styleFloat' : 'cssFloat'] = value;
			break;
		case 'right':
		case 'bottom':
			if (declinationFlag && value != 'auto') value = parseFloat(value) - 1 + 'px';
		default:
			elm.style[type] = value;
		}
	}
	function setStyles(elm, styles){
		for(var i in styles){
			setStyle(elm, i, styles[i]);
		}
	}
	
	function addEvent(elm, type, func){
		if (!elm) return;
		if (elm.addEventListener){
			if (type == 'mousewheel' && isGecko) type = 'DOMMouseScroll';
			elm.addEventListener(type, func, false);
		} else if(elm.attachEvent){
			elm.attachEvent('on' + type, func)
		}
	}
	function removeEvent(elm, type, func){
		if (!elm) return;
		if (elm.removeEventListener){
			if (type == 'mousewheel' && isGecko) type = 'DOMMouseScroll';
			elm.removeEventListener(type, func, false);
		} else if(elm.detachEvent){
			elm.detachEvent('on' + type, func)
		}
	}
	
	function bind(func, _this){
		return function(){ func.apply(_this, arguments); }
	}
	
	
	// Special Functions
	function setTimer(){
		if (timer) window.clearInterval(timer);
		if ($F('pitch') > 0 && $F('type') > 0) timer = window.setInterval(librate, $F('pitch'));
	}
	
	function getWindowSize(){
		if (document.documentElement && document.documentElement.clientWidth && !window.opera){
			return { x: document.documentElement.clientWidth, y: document.documentElement.clientHeight };
		} else if (document.body.clientWidth){
			return { x: document.body.clientWidth, y: document.body.clientHeight };
		} else {
			return { x: window.innerWidth, y: window.innerHeight };
		}
	}
	
	function adjust(){
		var oldSize = { x: size.x, y: size.y };
		size = getWindowSize();
		
		var adjustType = parseInt($F('adjustment'))
		var base       = parseInt($F('base'));
		if (adjustType == 0 || ddds.length == 0) return;
		
		var power = 1, kx = 0, ky = 0;
		if (adjustType == 3) adjustType = (size.x / oldSize.x < size.y / oldSize.y) ? 1 : 2;
		switch(adjustType){
		case 1:
			power = size.x / oldSize.x;
			switch(Math.floor(base / 3)){
			case 0:
				ky = 0;
				break;
			case 1:
				ky = (size.y - oldSize.y * power) / 2;
				break;
			case 2:
				ky =  size.y - oldSize.y * power;
				break;
			}
			break;
		case 2:
			power = size.y / oldSize.y;
			switch(base % 3){
			case 0:
				kx = 0;
				break;
			case 1:
				kx = (size.x - oldSize.x * power) / 2;
				break;
			case 2:
				kx =  size.x - oldSize.x * power;
				break;
			}
			break;
		}
		for(var i=0; i<ddds.length; i++){
			ddds[i].adjust(power, kx, ky);
		}
		setCookie();
	}
	
	function librate(){
		if (!LIBRATIONS[$F('type')] || drag.flag) return;
		for(var i=0; i<ddds.length; i++){
			LIBRATIONS[$F('type')].func.apply(ddds[i], [$F('power')]);
		}
	}
	
	function returnBasicPosition(){
		for(var i=0; i<ddds.length; i++){
			ddds[i].draw(ddds[i].x, ddds[i].y, ddds[i].size);
		}
	}
	
	function addDdd(event, type){
		event = new Event(event);
		if (event.rightClick) return;
		if (ddds.length >= MAXDDD){
			alert('最大数(' + MAXDDD + ')に達しています。不要なものを削除して下さい。');
			return;
		}
		
		var size = IMGSIZE * parseInt($F('size')) / MAXSIZE;
		var ddd = new DDD(type, event.client.x, event.client.y, size);
		$().appendChild(ddd.toElement());
		ddds.push(ddd);
		bind(ddd.startDrag, ddd)(event);
	}
	
	function dragging(event){
		if (!drag.flag) return;
		event = new Event(event);
		var x = event.client.x + drag.offX;
		var y = event.client.y + drag.offY;
		x = x < 0 ? 0 : x;
		y = y < 0 ? 0 : y;
		setStyles(drag.elm, {
			left: x - drag.size/2 + 'px',
			top:  y - drag.size/2 + 'px'
		});
		event.stop();
	}
	
	function onKeyDown(event){
		if (drag.flag || !drag._this) return;
		drag._this.onKeyDown(event);
	}
	
	function setCookie(){
		var size = getWindowSize();
		var text = (changeable ? 1 : 0) + ',';
		text += size.x + ',' + size.y + ',';
		text += $F('adjustment') + ',' + $F('base') + ',';
		text += $F('type') + ',' + $F('power') + ',' + $F('pitch') + ';'
		
		for(var i=0; i<ddds.length; i++){
			text += ddds[i].toString() + ';';
		}
		$('search').value = text.replace(/[^0-9,;]/g, '');
		if (!changeable) return;
		var d = new Date();
		d.setTime(d.getTime() + 30 * 24*60*60*1000);
		var path = '';
		if (location.host == 'www.geocities.jp' ||
		    location.host == 'www.ne.jp')
			path = 'path=' + location.pathname.replace(/(^\/[^\/]+)\/.*/, "$1") + ';';
		document.cookie = 'WebPageDododo=' + encodeURIComponent(text) + ';expires=' + d.toGMTString() + ';' + path;
	}
	
	
	function changeType(){
		if ($F('type') > 0){
			$('power').disabled = false;
			$('pitch').disabled = false;
		} else {
			$('power').disabled = true;
			$('pitch').disabled = true;
		}
		returnBasicPosition();
		setTimer();
		setCookie();
	}
	
	function changeAdjustment(){
		if ($F('adjustment') > 0){
			$('base').disabled = false;
		} else {
			$('base').disabled = true;
		}
		setCookie();
	}
	
	
	
	function getInformation(){
		var scripts = document.getElementsByTagName('script');
		for(var i=0; i<scripts.length; i++){
			var s = scripts[i];
			if (s.src && s.src.match(/wpd\.js(?:\?(.*))?$/)){
				path = s.src.replace(/wpd\.js(?:\?(.*))?$/, '');
				var queries = getQueries(RegExp.$1);
				if (queries.position){
					align  = queries.position.match(/L/i) ? 'left' : 'right';
					valign = queries.position.match(/U/i) ? 'top' : 'bottom';
				}
				var option = queries.option ? queries.option : '';
				if (document.cookie.match(/(?:^|;)WebPageDododo=([^;]+)/))
					option = decodeURIComponent(RegExp.$1);
				var tmp = option.split(';');
				for(var j=1; j<tmp.length; j++){
					var ddd = new DDD(tmp[j]);
					if (ddd.size) ddds.push(ddd);
				}
				return getBasicInformation(tmp[0]);
			}
		}
		return {};
		
		function getQueries(query){
			var tmp = query.split('&');
			var queries = {};
			for(var i=0; i<tmp.length; i++){
				if (tmp[i].match(/^([^=]+)=([^=]+)$/)){
					queries[RegExp.$1.toLowerCase()] = RegExp.$2;
				}
			}
			return queries;
		}
		
		function getBasicInformation(str){
			// changeable, x, y, adjustment, base, librationType, librationPower, librationPitch
			if (str.match(/^(\d+),(\d+),(\d+),(\d+),(\d+),(\d+),(\d+),(\d+)$/)){
				changeable = RegExp.$1 == 1;
				size.x = parseInt(RegExp.$2);
				size.y = parseInt(RegExp.$3);
				return {
					adjustment: parseInt(RegExp.$4),
					base:       parseInt(RegExp.$5),
					type:       parseInt(RegExp.$6),
					power:      parseInt(RegExp.$7),
					pitch:      parseInt(RegExp.$8)
				};
			}
			return {};
		}
	}
	
	
	function loadStyleSheet(){
		var link = createElement('link', {
			rel:  'stylesheet',
			type: 'text/css',
			href: path + 'wpd.css'
		}, {});
		document.getElementsByTagName('head')[0].appendChild(link);
	}
	
	
	function setSelectBoxs(info){
		setSelectBox($('type')      , info.type);
		setSelectBox($('power')     , info.power);
		setSelectBox($('pitch')     , info.pitch);
		setSelectBox($('adjustment'), info.adjustment);
		setSelectBox($('base')      , info.base);
		changeType();
		changeAdjustment();
	}
	function setSelectBox(sb, value){
		for(var i=0; i<sb.options.length; i++){
			if (sb.options[i].value == value) sb.selectedIndex = i;
		}
	}
	
	
	function makeDdds(){
		var div = $();
		for(var i=0; i<ddds.length; i++){
			div.appendChild(ddds[i].toElement());
		}
	}
	
	
	
	// Class - Event
	function Event(event){
		if (event && event.event) return event;
		event = this.event = event || window.event;
		this.wheelDelta = event.wheelDelta ? event.wheelDelta : event.detail;
		this.rightClick = (event.which == 3) || (event.button == 2);
		this.client = {
			x: event.pageX ? event.pageX - window.pageXOffset : event.clientX,
			y: event.pageY ? event.pageY - window.pageYOffset : event.clientY
		}
		this.keyCode = event.which || event.keyCode;
		this.stop = function(){
			if (this.event.stopPropagation) this.event.stopPropagation();
			else                            this.event.cancelBubble = true;
			if (this.event.preventDefault)  this.event.preventDefault();
			else                            this.event.returnValue = false;
		};
	}
	
	
	// Class - Gaon
	function Gaon(x, y){
		var elm = createElement('img', {
			src: path + 'thehand3.png',
			alt: ''
		}, {
			position: isIE6 ? 'absolute' : 'fixed',
			zIndex: maxZIndex++
		});
		$().appendChild(elm);
		
		var step = 0;
		var timer = setInterval(action, 1000/FPS);
		action();
		
		function action(){
			var size = 480 * Math.sin(Math.PI * ((step * 2) / (STEPS * 3) + 1/3));
			draw(size);
			if (++step > STEPS){
				$().removeChild(elm);
				clearInterval(timer);
			}
		}
		function draw(size){
			var dx = size/20 - size/10 * (step%2);
			setStyles(elm, {
				left: x - size/2 + dx + 'px',
				top:  y - size/2 + 'px',
				width:  size + 'px',
				height: size + 'px'
			});
		}
	}
	
	// Class - DDD
	function DDD(){
		if (arguments.length == 1){
			if (arguments[0].match(/^(\d+),(\d+),(\d+),(\d+)$/)){
				this.type = parseInt(RegExp.$1);
				this.x    = parseInt(RegExp.$2);
				this.y    = parseInt(RegExp.$3);
				this.size = parseInt(RegExp.$4);
			}
		} else if (arguments.length == 4){
			this.type = parseInt(arguments[0]);
			this.x    = parseInt(arguments[1]);
			this.y    = parseInt(arguments[2]);
			this.size = parseInt(arguments[3]);
		}
		if (this.type < 1 || this.type > DDDTYPES) this.size = null;
		this.limit();
		this.id = maxId++;
		this.src  = path + this.type + '.png';
	}
	DDD.prototype.toElement = function(){
		var img = createElement('img', {
			id:  'WebPageDododo_' + this.id,
			src: this.src,
			alt: ''
		}, {
			position: isIE6 ? 'absolute' : 'fixed',
			zIndex: maxZIndex++
		});
		this.elm = img;
		this.draw(this.x, this.y, this.size);
		if (changeable){
			addEvent(img, 'mousewheel', bind(this.onMouseWheel, this));
			addEvent(img, 'mousedown',  bind(this.startDrag, this));
		}
		return img;
	};
	DDD.prototype.toString = function(){
		return Math.round(this.type) + ',' +
		       Math.round(this.x) + ',' + Math.round(this.y) + ',' +
		       Math.round(this.size);
	};
	DDD.prototype.draw = function(x, y, size){
		setStyles(this.elm, {
			left:  x - size/2 + 'px',
			top:   y - size/2 + 'px',
			width:  size + 'px',
			height: size + 'px'
		});
	};
	DDD.prototype.remove = function(){
		$().removeChild(this.elm);
		this.size = 0;
	};
	DDD.prototype.gaon = function(){
		if (drag.elm != $('theHand')) return;
		new Gaon(this.x, this.y);
		this.remove();
	};
	DDD.prototype.adjust = function(power, kx, ky){
		this.size = this.size * power;
		this.x = this.x * power + kx;
		this.y = this.y * power + ky;
		
		this.limit();
		this.draw(this.x, this.y, this.size);
	};
	DDD.prototype.limit = function(){
		this.size = (this.size < 16) ? 16 : (this.size > IMGSIZE) ? IMGSIZE : this.size;
		this.x    = (this.x < 0) ? 0 : this.x;
		this.y    = (this.y < 0) ? 0 : this.y;
	};
	DDD.prototype.onMouseWheel = function(event){
		event = new Event(event);
		this.size *= event.wheelDelta < 0 ? 0.9 : 1.1;
		this.limit();
		this.draw(this.x, this.y, this.size);
		event.stop();
		setCookie();
	};
	DDD.prototype.onKeyDown = function(event){
		event = new Event(event);
		if (window.opera){
			if (event.keyCode != 43 && event.keyCode != 45 && event.keyCode != 59) return;
			this.size *= (event.keyCode == 45) ? 0.9 : 1.1;
		} else if (event.keyCode == 107 || event.keyCode == 109){
			this.size *= (event.keyCode == 107) ? 1.1 : 0.9;
		} else if (isGecko){
			if (event.keyCode != 61) return;
			this.size *= 1.1;
		} else if (event.keyCode == 187 || event.keyCode == 189){
			this.size *= (event.keyCode == 187) ? 1.1 : 0.9;
		} else {
			return;
		}
		this.limit();
		this.draw(this.x, this.y, this.size);
		setCookie();
	}
	DDD.prototype.startDrag = function(event){
		event = new Event(event);
		if (event.rightClick) return;
		
		this.draw(this.x, this.y, this.size);
		drag.elm = this.elm;
		drag.flag = true;
		drag._this = this;
		drag.offX = this.x - event.client.x;
		drag.offY = this.y - event.client.y;
		drag.size = this.size;
		addEvent(document, 'mousemove', dragging);
		addEvent(document, 'mouseup', this.endDrag);
		event.stop();
	};
	DDD.prototype.endDrag = function(event){
		if (!drag.flag) return;
		drag._this.x = parseInt(drag.elm.style.left) + drag._this.size / 2;
		drag._this.y = parseInt(drag.elm.style.top ) + drag._this.size / 2;
		drag.flag = false;
		
		removeEvent(document, 'mousemove', dragging);
		removeEvent(document, 'mouseup', drag._this.endDrag);
		setCookie();
	};
	
	// start
	(function(){
		if ($()) return;
		var info = getInformation();
		loadStyleSheet();
		ready();
		setSelectBoxs(info);
		makeDdds();
		adjust();
		addEvent(window, 'resize', adjust);
		if (changeable) addEvent(document, 'keydown', onKeyDown);
		setTimer();
		setCookie();
	})();
})();
